scala.tools.scalap.scalax.rules.scalasig

# ClassFileParser

###
Related Doc: package scalasig

#### object ClassFileParser extends ByteCodeReader

Source
  ClassFileParser.scala

Linear Supertypes
ByteCodeReader, RulesWithState, StateRules, Rules, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ClassFileParser
2. ByteCodeReader
3. RulesWithState
4. StateRules
5. Rules
6. AnyRef
7. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1. #### case class Annotation(typeIndex: Int, elementValuePairs: Seq[AnnotationElement]) extends ElementValue with Product with Serializable

2. #### case class AnnotationElement(elementNameIndex: Int, elementValue: ElementValue) extends Product with Serializable

3. #### case class ArrayValue(values: Seq[ElementValue]) extends ElementValue with Product with Serializable

4. #### case class ClassInfoIndex(index: Int) extends ElementValue with Product with Serializable

5. #### case class ConstValueIndex(index: Int) extends ElementValue with Product with Serializable

6. #### class DefaultRule[In, Out, A, X] extends Rule[In, Out, A, X]

   Definition Classes
     Rules

7. #### abstract class ElementValue extends AnyRef

8. #### case class EnumConstValue(typeNameIndex: Int, constNameIndex: Int) extends ElementValue with Product with Serializable

9. #### trait FromRule[In] extends AnyRef

   Definition Classes
     Rules

10. #### type Parser[A] = rules.Rule[S, S, A, String]

    Definition Classes
      ByteCodeReader

11. #### type Rule[+A, +X] = rules.Rule[S, S, A, X]

    Definition Classes
      StateRules

12. #### type S = ByteCode

    Definition Classes
      ByteCodeReader → StateRules

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### def add1[T](f: (T) ⇒ (ConstantPool) ⇒ Any)(raw: T)(pool: ConstantPool): ConstantPool

5. #### def add2[T](f: (T) ⇒ (ConstantPool) ⇒ Any)(raw: T)(pool: ConstantPool): ConstantPool

6. #### def allOf[A, X](rules: Seq[Rule[A, X]]): (S) ⇒ Result[S, List[A], X]

   Create a rule that succeeds if all of the given rules succeed.

   Create a rule that succeeds if all of the given rules succeed.

   rules

     the rules to apply in sequence.

   Definition Classes
     StateRules

7. #### val annotation: Parser[Annotation]

8. #### val annotations: rules.Rule[S, S, Seq[Annotation], String]

9. #### def anyOf[A, X](rules: Seq[Rule[A, X]]): rules.Rule[S, S, collection.immutable.List[A], X]

   Create a rule that succeeds with a list of all the provided rules that succeed.

   Create a rule that succeeds with a list of all the provided rules that succeed.

   rules

     the rules to apply in sequence.

   Definition Classes
     StateRules

10. #### def apply[A, X](f: (S) ⇒ Result[S, A, X]): rules.Rule[S, S, A, X]

    Definition Classes
      StateRules

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

12. #### val attribute: rules.Rule[S, S, Attribute, Nothing]

13. #### val attributes: rules.Rule[S, S, Seq[Attribute], Nothing]

14. #### val byte: rules.Rule[S, S, Byte, Nothing]

    Definition Classes
      ByteCodeReader

15. #### def bytes(n: Int): rules.Rule[S, S, ByteCode, Nothing]

    Definition Classes
      ByteCodeReader

16. #### val classFile: rules.Rule[S, S, ClassFile, String]

17. #### val classRef: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

18. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

19. #### def cond(f: (S) ⇒ Boolean): rules.Rule[S, S, S, Nothing]

    Create a rule that identities if f(in) is true.

    Create a rule that identities if f(in) is true.

    Definition Classes
      StateRules

20. #### val constantPool: rules.Rule[S, S, ConstantPool, Nothing]

21. #### val constantPoolEntry: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

22. #### val doubleConstant: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

23. #### def element_value: Parser[ElementValue]

24. #### val element_value_pair: rules.Rule[S, S, AnnotationElement, String]

25. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

26. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

27. #### def error[X](err: X): rules.Rule[Any, Nothing, Nothing, X]

    Definition Classes
      Rules

28. #### def error[In]: rules.Rule[In, Nothing, Nothing, In]

    Definition Classes
      Rules

29. #### def expect[In, Out, A, Any](rule: rules.Rule[In, Out, A, Any]): (In) ⇒ A

    Converts a rule into a function that throws an Exception on failure.

    Converts a rule into a function that throws an Exception on failure.

    Definition Classes
      Rules

30. #### val factory: RulesWithState

    Definition Classes
      RulesWithState → StateRules

31. #### def failure: rules.Rule[Any, Nothing, Nothing, Nothing]

    Definition Classes
      Rules

32. #### val field: rules.Rule[S, S, Field, Nothing]

33. #### val fieldRef: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

34. #### val fields: rules.Rule[S, S, Seq[Field], Nothing]

35. #### val floatConstant: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

36. #### def from[In]: FromRule[In]

    Definition Classes
      Rules

37. #### def get: rules.Rule[S, S, S, Nothing]

    Definition Classes
      StateRules

38. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

39. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()

40. #### val header: rules.Rule[S, S, ClassFileHeader, String]

41. #### implicit def inRule[In, Out, A, X](rule: rules.Rule[In, Out, A, X]): InRule[In, Out, A, X]

    Definition Classes
      Rules

42. #### val intConstant: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

43. #### val interfaceMethodRef: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

44. #### val interfaces: rules.Rule[S, S, Seq[Int], Nothing]

45. #### val invokeDynamic: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

46. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

47. #### val longConstant: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

48. #### val magicNumber: rules.Rule[S, S, Int, String]

49. #### def memberRef(description: String): rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

50. #### val method: rules.Rule[S, S, Method, Nothing]

51. #### val methodHandle: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

52. #### val methodRef: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

53. #### val methodType: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

54. #### val methods: rules.Rule[S, S, Seq[Method], Nothing]

55. #### val nameAndType: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

56. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

57. #### def nil: rules.Rule[S, S, collection.immutable.Nil.type, Nothing]

    Definition Classes
      StateRules

58. #### def none: rules.Rule[S, S, None.type, Nothing]

    Definition Classes
      StateRules

59. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

60. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

61. #### def oneOf[In, Out, A, X](rules: rules.Rule[In, Out, A, X]*): rules.Rule[In, Out, A, X]

    Definition Classes
      Rules

62. #### def parse(byteCode: ByteCode): ClassFile

63. #### def parseAnnotations(byteCode: ByteCode): Seq[Annotation]

64. #### def read[A](f: (S) ⇒ A): rules.Rule[S, S, A, Nothing]

    Definition Classes
      StateRules

65. #### def repeatUntil[T, X](rule: Rule[(T) ⇒ T, X])(finished: (T) ⇒ Boolean)(initial: T): rules.Rule[S, S, T, X]

    Repeatedly apply a rule from initial value until finished condition is met.

    Repeatedly apply a rule from initial value until finished condition is met.

    Definition Classes
      StateRules

66. #### implicit def rule[In, Out, A, X](f: (In) ⇒ Result[Out, A, X]): rules.Rule[In, Out, A, X]

    Definition Classes
      Rules

67. #### def ruleWithName[In, Out, A, X](_name: String, f: (In) ⇒ Result[Out, A, X]): rules.Rule[In, Out, A, X] with Name

    Definition Classes
      Rules

68. #### implicit def seqRule[In, A, X](rule: rules.Rule[In, In, A, X]): SeqRule[In, A, X]

    Definition Classes
      Rules

69. #### def set(s: ⇒ S): rules.Rule[S, S, S, Nothing]

    Definition Classes
      StateRules

70. #### def state[s]: StateRules { type S = s }

    Definition Classes
      Rules

71. #### val stringRef: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

72. #### def success[Out, A](out: Out, a: A): rules.Rule[Any, Out, A, Nothing]

    Definition Classes
      Rules

73. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

74. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

75. #### val u1: rules.Rule[S, S, Int, Nothing]

    Definition Classes
      ByteCodeReader

76. #### val u2: rules.Rule[S, S, Int, Nothing]

    Definition Classes
      ByteCodeReader

77. #### val u4: rules.Rule[S, S, Int, Nothing]

    Definition Classes
      ByteCodeReader

78. #### def unit[A](a: ⇒ A): rules.Rule[S, S, A, Nothing]

    Definition Classes
      StateRules

79. #### def update(f: (S) ⇒ S): rules.Rule[S, S, S, Nothing]

    Definition Classes
      StateRules

80. #### val utf8String: rules.Rule[S, S, (ConstantPool) ⇒ ConstantPool, Nothing]

81. #### val version: rules.Rule[S, S, (Int, Int), Nothing]

82. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

83. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

84. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from ByteCodeReader

### Inherited from RulesWithState

### Inherited from StateRules

### Inherited from Rules

### Inherited from AnyRef

### Inherited from Any

### Ungrouped